# ISO-8859-1 Converter to UTF-8
# Converts an XML-File encoded in ISO-8859-1 to UTF-8
# Reads from stdin, writes to stdout so it can be piped easily

use Unicode::String qw(utf8 latin1);
use strict;

my $line;
my $utf_line;

foreach $line (<>) {
  if ($line =~ /<\?xml.+encoding\s*=\s*["']\s*iso-8859-1.*/i) {
    $line =~ s/iso-8859-1/UTF-8/i;
    print "$line";
  }
  else {
    $utf_line = latin1($line);
    print $utf_line->utf8;
  }
}




