#! /usr/sepp/bin/perl-5.6.0
#This programs converts LaTeX special characters in unicode format
#Usage: ./converter infile

#Reading the input file
$text = "";
LINE:
while (<>){

#riassumere questa in una sola regexp
s/\\(i|j|l|L|S|P|o|O)\ /\\$1\{\}/g;
s/\\(i|j|l|L|S|P|o|O)~/\\$1\{\}\ /g;
s/\\(i|j|l|L|S|P|o|O)\\\ /\\$1\{\}\ /g;
s/\{\\(i|j|l|L|S|P|o|O)\}/\\$1\{\}/g;

s/(\\`)\ *(([a-zA-Z])|((\\(i|j|l|L|S|P|o|O))\{\}))/$1\{$3$5\}/g;
s/(\\')\ *(([a-zA-Z])|((\\(i|j|l|L|S|P|o|O))\{\}))/$1\{$3$5\}/g;
s/(\\\^)\ *(([a-zA-Z])|((\\(i|j|l|L|S|P|o|O))\{\}))/$1\{$3$5\}/g;
s/(\\")\ *(([a-zA-Z])|((\\(i|j|l|L|S|P|o|O))\{\}))/$1\{$3$5\}/g;
s/(\\=)\ *(([a-zA-Z])|((\\(i|j|l|L|S|P|o|O))\{\}))/$1\{$3$5\}/g;
s/(\\~)\ *(([a-zA-Z])|((\\(i|j|l|L|S|P|o|O))\{\}))/$1\{$3$5\}/g;
s/(\\\.)\ *(([a-zA-Z])|((\\(i|j|l|L|S|P|o|O))\{\}))/$1\{$3$5\}/g;

s/(\\u)((\ +([a-zA-Z]))|(\ *((\\(i|j|l|L|S|P|o|O))\{\})))/$1\{$4$7\}/g;
s/(\\v)((\ +([a-zA-Z]))|(\ *((\\(i|j|l|L|S|P|o|O))\{\})))/$1\{$4$7\}/g;
s/(\\H)((\ +([a-zA-Z]))|(\ *((\\(i|j|l|L|S|P|o|O))\{\})))/$1\{$4$7\}/g;
s/(\\b)((\ +([a-zA-Z]))|(\ *((\\(i|j|l|L|S|P|o|O))\{\})))/$1\{$4$7\}/g;
s/(\\c)((\ +([a-zA-Z]))|(\ *((\\(i|j|l|L|S|P|o|O))\{\})))/$1\{$4$7\}/g;
s/(\\d)((\ +([a-zA-Z]))|(\ *((\\(i|j|l|L|S|P|o|O))\{\})))/$1\{$4$7\}/g;

#s/(\\t)((\ +([a-zA-Z]([a-zA-Z]|\\i|\\j)))|(\ *((\\i|\\j)[a-zA-Z]|\\i|\\j)))/$1\{$4$7\}/g;

#Uniformig LaTeX delimiters
#eg Bib\TeX\ ML --> Bib{\TeX} ML
#s/(\\[a-zA-Z]+)\s/\{\1\} /g;
#eg Bib\TeX~ML --> Bib{\TeX} ML
#s/(\\[a-zA-Z]+)~/\{\1\} /g;
#eg Bib\TeX{}ML --> Bib{\TeX}ML
#s/(\\[a-zA-Z]+)\{\}/\{\1\}/g;
#eg -- --> {--} ;  --- --> {---}
#s/(\-{2,3})/\{\1\}/g; 

#Applying tranformations
 
s/\\#/&#x0023;/g;
s/\\%/&#x0025;/g;
s/\\&/&#x0026;/g;
s/\\~{}/&#126;/g;
s/\!`/&#161;/g;
s/\\S{}/&#167;/g;
s/\\"{}/&#168;/g;
s/\\copyright{}/&#169;/g;
s/\\-/&#173;/g;
s/\\={}/&#175;/g;
s/\\\'{}/&#180;/g;
s/\\P{}/&#182;/g;
s/\\c{ }/&#184;/g;
s/\?`/&#191;/g;
s/\\`{A}/&#192;/g;
s/\\\'{A}/&#193;/g;
s/\\\^{A}/&#194;/g;
s/\\~{A}/&#195;/g;
s/\\"{A}/&#196;/g;
s/\\r{A}/&#197;/g;
s/\\AE{}/&#198;/g;
s/\\c{C}/&#199;/g;
s/\\`{E}/&#200;/g;
s/\\\'{E}/&#201;/g;
s/\\\^{E}/&#202;/g;
s/\\"{E}/&#203;/g;
s/\\`{I}/&#204;/g;
s/\\\'{I}/&#205;/g;
s/\\\^{I}/&#206;/g;
s/\\"{I}/&#207;/g;
s/\\DH{}/&#208;/g;
s/\\~{N}/&#209;/g;
s/\\`{O}/&#210;/g;
s/\\\'{O}/&#211;/g;
s/\\\^{O}/&#212;/g;
s/\\~{O}/&#213;/g;
s/\\"{O}/&#214;/g;
s/\\O{}/&#216;/g;
s/\\`{U}/&#217;/g;
s/\\\'{U}/&#218;/g;
s/\\\^{U}/&#219;/g;
s/\\"{U}/&#220;/g;
s/\\\'{Y}/&#221;/g;
s/\\TH{}/&#222;/g;
s/\\ss{}/&#223;/g;
s/\\`{a}/&#224;/g;
s/\\\'{a}/&#225;/g;
s/\\\^{a}/&#226;/g;
s/\\~{a}/&#227;/g;
s/\\"{a}/&#228;/g;
s/\\r{a}/&#229;/g;
s/\\ae{}/&#230;/g;
s/\\c{c}/&#231;/g;
s/\\`{e}/&#232;/g;
s/\\\'{e}/&#233;/g;
s/\\\^{e}/&#234;/g;
s/\\"{e}/&#235;/g;
s/\\`{\\i}/&#236;/g;
s/\\\'{\\i}/&#237;/g;
s/\\\^{\\i}/&#238;/g;
s/\\"{\\i}/&#239;/g;
s/\\dh{}/&#240;/g;
s/\\~{n}/&#241;/g;
s/\\`{o}/&#242;/g;
s/\\\'{o}/&#243;/g;
s/\\\^{o}/&#244;/g;
s/\\~{o}/&#245;/g;
s/\\"{o}/&#246;/g;
s/\\ensuremath{\div}/&#247;/g;
s/\\o{}/&#248;/g;
s/\\`{u}/&#249;/g;
s/\\\'{u}/&#250;/g;
s/\\\^{u}/&#251;/g;
s/\\"{u}/&#252;/g;
s/\\\'{y}/&#253;/g;
s/\\th{}/&#254;/g;
s/\\"{y}/&#255;/g;


#Deleting braces around unicode, 
s/\{(\&\#x?\d+\;)\}/\1/g; 


s/\{\\LaTeXe\}/<tex code="\\LaTeXe">LaTeXe<\/tex>/g;

s/\{\\LaTeX\}/<tex code="\\LaTeX">LaTeX<\/tex>/g;

s/\{\\TeX\}/<tex code="\\TeX">TeX<\/tex>/g;


#Transforming non-recognized LaTex entries
#s/\{\\([a-z,A-Z]+)\}/<tex code="\\\1">\1<\/tex>/g;
#Securing {xxx} entries
#s/\{(.+?)\}/<tex code="\1">\1<\/tex>/g;

#Printing error messages for not recognised symbols
select STDERR;
while (/(code=\")?(\\\S+)(\")?/g){
  if($1 ne "code=\"" and $3 ne "\""){
    print "WARNING: found an unknown symbol in line $.: $2\n";
  }
}
select STDOUT;   

#Deleting " delimiters
s/>"/>/g;
s/"</</g;

print $_;
}
